;
; Cabamap - CAlculator BAsed MAthematics Platform
;
; Version 1.02
;
; Copyright (C) 2003-2006, by Michael Vincent. All rights reserved.
;
; Project started 01-01-03.
;
;
;
;	This program is free software; you can redistribute it and/or modify
;	it under the terms of the GNU General Public License as published by
;	the Free Software Foundation; either version 2 of the License, or
;	(at your option) any later version.
;
;	This program is distributed in the hope that it will be useful,
;	but WITHOUT ANY WARRANTY; without even the implied warranty of
;	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;	GNU General Public License for more details.
;
;	You should have received a copy of the GNU General Public License
;	along with this program; if not, write to the Free Software
;	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 NOLIST
 INCLUDE "../ti83plus.inc"
 INCLUDE "../michael.inc"
 LIST
 INCLUDE "equates.inc"
 INCLUDE "header.inc"
App_Info:
	;Returns version and other useful informationn
	;Register A - version, 1.02 is 02h
	ld a,2
	ret
AppGo:
;Startup code...initialize the environment
	B_CALL GetBaseVer
	ld c,b
	ld b,a
	ld hl,1*256+12
	or a
	sbc hl,bc
	jr nc,AppGo_Not113
	ld a,0FFh
	B_CALL SetExSpeed
AppGo_Not113:
	B_CALL ForceFullScreen
	ld hl,AppVectors
	B_CALL AppInit
	;Secret flags
	xor a
	ld (iy+asm_Flag1),a
	call SplashScreen
	B_CALL DelRes		;invalidate the statistics memory area
	B_CALL CleanAll
	;Insert all free memory
	ld hl,OP1
	ld (hl),01h
	inc hl
	ld (hl),24h
	inc hl
	ld de,(pTempCnt)
	ld (hl),e
	inc hl
	ld (hl),d
	inc de
	ld (pTempCnt),de
	inc hl
	ld (hl),0
	ld de,workingspace
	B_CALL MovFrOP1
	B_CALL MemChk
	ld bc,50			;okay we actually leave 50 bytes - just in case something ever decides to make a small variable
	sbc hl,bc
	B_CALL CreateStrng ;all free RAM goes into the string
	inc de
	inc de
	ld (mathAreaStart),de
	ld (areaFreeStart),de
	dec de
	dec de
	ex de,hl
	ld e,(hl)
	inc hl
	ld d,(hl)
	add hl,de
	ld (mathAreaEnd),hl
	ld (areaFreeEnd),hl
	;Memory is initialized...load the interface
	B_CALL ClrScrnFull
	ld hl,6
	ld (currow),hl
	ld hl,rpnStackStart
	ld (rpnNextEntry),hl		;clear RPN stack
	xor a
	ld (rpnEntryCount),a
	res flagInputActive,(iy+asm_Flag1)
	jp Interface
 INCLUDE "interface.asm"
 INCLUDE "functions.asm"
 INCLUDE "error.asm"
MemoryError:
	ld a,eMemory
	jr GenericError
BreakError:
	ld a,eBreak
	jr GenericError
StackCountError:
	ld a,eStackCount
	jr GenericError
DomainError:
	ld a,eDomain
GenericError:
	ld sp,(errorStack)
	ld hl,(errorPointer)
	jp (hl)
App_Exit:
	B_CALL CleanAll
	B_CALL ReloadAppEntryVecs
	B_CALL JForceCmdNoChar
AppVectors:
	DW DummyReturn
	DW DummyReturn
	DW AppPutAway
	DW DummyReturn
	DW DummyReturn
	DW DummyReturn
	DB appTextSaveF
AppPutAway:
	res plotloc,(iy+plotflags)
	res textwrite,(iy+sgrflags)
	B_CALL ReloadAppEntryVecs
	ld (iy+textflags),0
	bit monAbandon,(iy+monFlags)
	jr nz,AppPutAway_Off
	ld a,11
	out (3),a
	B_CALL LCD_DRIVERON
	set onRunning,(iy+onFlags)
	ei
	B_JUMP JForceCmdNoChar
AppPutAway_Off:
	B_JUMP PutAway
putstr:
	ld a,(hl)
	inc hl
	or a
	ret z
	B_CALL PutC
	jr putstr
vputstr:
	ld a,(hl)
	inc hl
	or a
	ret z
	cp 0FFh
	jr z,vputstr_newline
	B_CALL VPutMap
	jr vputstr
vputstr_newline:
	xor a
	ld (pencol),a
	ld a,(penrow)
	add a,7
	ld (penrow),a
	jr vputstr
 INCLUDE "add.asm"
 INCLUDE "sub.asm"
 INCLUDE "mul.asm"
 INCLUDE "div.asm"
 INCLUDE "sqrt.asm"
 INCLUDE "prime.asm"
 INCLUDE "factorial.asm"
 INCLUDE "exponent.asm"
 INCLUDE "probability.asm"
 INCLUDE "log.asm"
 INCLUDE "math.asm"
 INCLUDE "display.asm"
 INCLUDE "splash.asm"
 INCLUDE "export.asm"
 ;INCLUDE "games.asm"
