;	This program is free software; you can redistribute it and/or modify
;	it under the terms of the GNU General Public License as published by
;	the Free Software Foundation; either version 2 of the License, or
;	(at your option) any later version.
;
;	This program is distributed in the hope that it will be useful,
;	but WITHOUT ANY WARRANTY; without even the implied warranty of
;	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;	GNU General Public License for more details.
;
;	You should have received a copy of the GNU General Public License
;	along with this program; if not, write to the Free Software
;	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
Permutation:
	;Input - HL points to the n, DE to the r
	;Output - HL is the result
	inc hl
	ld a,(hl)
	dec hl
	bit 7,a
	jp nz,DomainError
	inc de
	ld a,(de)
	dec de
	bit 7,a
	jp nz,DomainError
	;Clone
	push de
	call BCD_Clone
	pop de
	;HL is cloned...now DE
	push hl
	ex de,hl
	call BCD_Clone
	ex de,hl
	pop hl
	ex de,hl
	call BCD_CheckZero
	ex de,hl
	jp z,ReturnOne
	call BCD_Compare
	jp c,ReturnZero
	;
	ld (temp8),hl
	ld (temp9),de
	;Initialize
	call ReturnOne
	;Logic:
	;x1 nPr x2
	;t=1; t=t*x1; x2--;x1--; if (x2 <> 0) repeat
	;HL points to the initial variable T
	ld (temp10),hl
Permutation_Loop:
	bit onInterrupt,(iy+onFlags)
	jp nz,BreakError
	ld hl,(temp10)
	ld de,(temp8)
	call BCD_Multiply
	;HL is the result...shift it over the previous T
	push hl
	ld a,(hl)
	inc hl
	ld h,(hl)
	res 7,h
	ld l,a
	;HL is the length of the new number
	ld de,(temp10)
	ld a,(de)
	ld c,a
	inc de
	ld a,(de)
	res 7,a
	ld b,a
	;BC is the old
	or a
	sbc hl,bc
	;HL is the difference
	ld c,l
	ld b,h
	ld hl,(areaFreeStart)
	or a
	sbc hl,bc
	ld (areaFreeStart),hl
	pop hl
	ld de,(temp10)
	ld c,(hl)
	inc hl
	ld b,(hl)
	res 7,b
	dec hl
	inc bc
	inc bc
	ldir
	;Done...now decrement the x1 and x2
	ld hl,(temp8)
	call BCD_Decrement
	ld hl,(temp9)
	push hl
	call BCD_Decrement
	pop hl
	call BCD_CheckZero
	jr nz,Permutation_Loop
	ld hl,(temp10)
	ret
Combination:
	;Performs x1 nCr x2
	;Input - HL (x1), DE (x2)
	;Outputs: HL is the nCr
	push de
	push hl
	ex de,hl
	call BCD_Clone
	ld b,h
	ld c,l
	pop hl
	pop de
	push bc
	call Permutation
	;HL is the permutation...now divide by the factorial of x2
	pop de
	ex de,hl
	push de	;DE is the permutation result...HL is x2
	call Factorial
	pop de
	ex de,hl
	jp BCD_Division